//---------------------------------------------------------------------------
// Calculates the actual elevation, azimut and slantrange of given satellite
// on a given observationpoint of the earth
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <math.h>
#include <fstream.h>

#include "Satellit.h"
#include "aa.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)


#define sathoehe 42233.0

extern double heigth;  // import from sternzei.cpp
extern double laenge;  // import from sternzei.cpp
extern double breite;  // import from sternzei.cpp

//---------------------------------------------------------------------------

void GetParametersAndSatellit(float SatLen, float *Azi, float *Ele, float *Range) // stlich negativ
{
    float Heff, Slantrange;
    float degelevation,radbreite,zwiwert,elevation;
    float degwinkel,degazimut,winkel,azimut;

   Heff = EarthRadius + heigth/1000.0; // [km]

   radbreite = breite * DToR;

   degwinkel = SatLen - laenge;  // Abweichung in Grad
   winkel = degwinkel * DToR; // Abweichung von Greenwich in rad
   azimut = atan(tan(winkel) / sin(radbreite)); // rad
   degazimut = azimut * RToD; // Grad

   Slantrange = sqrt( (sathoehe * sathoehe) + (Heff * Heff) -
             2 * sathoehe * Heff * cos(winkel) * cos(radbreite));

   zwiwert = (sathoehe * cos(radbreite) * cos(winkel) - Heff) / Slantrange;

   elevation = atan(zwiwert / sqrt(1 - zwiwert * zwiwert));
   degelevation = elevation * RToD; // Grad

   *Azi   = 180.0 + degazimut; // 0degree north, 180degree south
   *Ele   = degelevation;
   *Range = Slantrange; // km
}

//---------------------------------------------------------------------------

